package simplebattleship;

public class Board 
{
	public static final String [] SHIP_NAMES = {"Pets.com","AskMe.com", "Go2.com"};
	
	
	private Cell [] _cells;
	private Ship [] _ships;
	private int _totalShips=0;
	
	public Board (int size, int maxShips)
	{
		_cells=new Cell[size];
		for(int i=0;i<size;i++)
			_cells[i]=new Cell();
		_ships=new Ship[maxShips];
	}
	
	public boolean addShip(int startPosition, int shipID)
	{
		Cell [] shipCells=new Cell[Ship.SHIP_LENGTH];
		int totalCells=0;
		for(int i=startPosition;i<Math.min(startPosition+Ship.SHIP_LENGTH,_cells.length);i++,totalCells++)
		{
			if(!_cells[i].isOccupied() && !aroundIsOccupied(i))
			{
				shipCells[totalCells]=_cells[i];
			}
			else
				return false;
		}
		
		if(totalCells==Ship.SHIP_LENGTH)
		{
			_ships[_totalShips]=new Ship(_totalShips,shipCells, startPosition);
			for(int i=startPosition;i<startPosition+Ship.SHIP_LENGTH;i++)
				_cells[i].setOccupied(_totalShips);
			_totalShips++;
			return true;
		}
		
		return false;
	}
	
	private boolean aroundIsOccupied(int cellID)
	{
		if(cellID>0 && _cells[cellID-1].isOccupied())
			return true;
		if(cellID<_cells.length-1 && _cells[cellID+1].isOccupied())
			return true;
		return false;
	}
	
	public Ship getHit(int cellID)
	{
		if(_cells[cellID].isOccupied())
		{
			_cells[cellID].setDamaged();
			return _ships[_cells[cellID]._shipID];
		}
		else
			_cells[cellID].setAttempted();
		return null;
	}
	
	public String toString()
	{
		String ret="";
		for(int i=0;i<_cells.length;i++)
		{
			ret+=i+"\t";
		}
		ret+=System.getProperty("line.separator");
		for(int i=0;i<_cells.length;i++)
		{
			if(_cells[i].isAttempted())
				ret+="v"+"\t";
			else if(_cells[i].isDamaged())
				ret+="X"+"\t";			
			else
				ret+="_"+"\t";
		}
		return ret;
	}
}
