package simplebattleship;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class GameUI 
{
	private Board _board;
	private int _boardSize;
	
	public GameUI(Board board, int boardSize)
	{
		_board=board;
		_boardSize=boardSize;
	}
	
	public void displayBoard()
	{
		System.out.println();
		System.out.println("************Game state **");
		System.out.println(_board.toString());
	}
	
	public int getLocationFromUser()
	{
		int locationCell=-1;
		
		System.out.println("Enter location - enter a number between 0 and " +(_boardSize-1));
					
		try{
		    BufferedReader bufferRead = new BufferedReader(new InputStreamReader(System.in));
		    String s = bufferRead.readLine();
		    locationCell=Integer.parseInt(s);
		    if(locationCell<0|| locationCell>=_boardSize)
		    {
		    	System.out.println("You entered invalid number. Please review the rules of the game and try again." );
				System.exit(0);
		    }
		}
		catch(IOException ioe)
		{
			System.out.println("Unexpected error: "+ioe.getMessage() );
			System.exit(0);
		}
		catch(NumberFormatException nfe)
		{
			System.out.println("You entered invalid number. Please review the rules of the game and try again." );
			System.exit(0);
		}
		return locationCell;
	}
	
	public void displayResult(Result result)
	{
		System.out.println(result.toString());
	}
	
	public void displayGameEnd(int attempts)
	{
		System.out.println("Success! It took you "+attempts+" moves to sink all the ships.");
	}
}
